//------------------------------------------------------------------------------
//
//  npkml.c
//
//  ANTz application based on NPE
//
//  Created by Shane Saxon on 3/15/11.
//  Copyright Saxon Digital 2010-2011. All rights reserved.
//
//-----------------------------------------------------------------------------

#include "npkml.h"

#include "../../os/npos.h"
#include "../npfile.h"


//-----------------------------------------------------------------------------
void npInitKML (void* dataRef)
{

}

//-----------------------------------------------------------------------------
void npCloseKML (void* dataRef)
{

}

//-----------------------------------------------------------------------------
// mode usage: 3 parameters "r/w/a" followed by optional "b" and optional "+"
// example mode = "rb+"
// r open file for reading
// w open file for overwriting. Create new file if doesn't already exist
// a open file for appending data. 
// b open file as a binary file
// + open file for read and writing
//-----------------------------------------------------------------------------
FILE* npOpenKML (const char* fileName, const char* mode, void* dataRef)
{
	FILE* file = NULL;

	file = fopen(fileName, mode); 

	if ( file == NULL )
	{
		perror("Failed to open/create file");
		return NULL;
	}

	// add code to add the file ptr to the data->map							debug, zz

	return file;
}


//-----------------------------------------------------------------------------
int npReadKML (void* readBuffer, int elementSize, int elementCount, 
				 FILE* file, void* dataRef)
{
	int bytes = 0;

	bytes = fread (readBuffer, elementSize, elementCount, file);
	
	if ( bytes == 0 )
		printf("Failed Reading\n");
	else
		printf("Success Reading\n");

	return bytes;
}


//-----------------------------------------------------------------------------
void npTestKML (void* fileName, int wordSize, int size, void* dataRef)
{
	FILE *file;
	size_t count;
	char *str = (char*)fileName;
	int i = 0;


	char buffer[256];
/*
	// get the Current Working Directory
	npGetCWD (buffer, &size);

	printf("CWD path : ");
	for(i = 0; i < size; i++)
		printf ("%c", buffer[i]);

	printf("\n");
*/
	// open/create and write to the file, "w" overwrites existing files
	file = npOpenKML (fileName, "r+", dataRef);

	// write the file path in the file as text
	count = npWriteKML (buffer, 1, strlen(buffer), file, dataRef);

	printf("wrote %d bytes.\n", count); 

	// read the file
//	npFileRewind(file);

	size = npReadKML (buffer, 1, 256, file, dataRef);


	printf("file contents : \n");
	for(i = 0; i < size; i++)
		printf ("%c", buffer[i]);

//mkdir(strB, S_IRWXU | S_IRWXG | S_IROTH | S_IXOTH);

 

return;
}

//-----------------------------------------------------------------------------
FILE* npKMLDialog (const char* fileName, int dialogType, void* dataRef)
{	
	
	switch (dialogType)
	{
		case kNPfileDialogNew : ; break;

		case kNPfileDialogOpen : ; break;
		case kNPfileDialogClose : ; break;

		case kNPfileDialogSave : ; break;
		case kNPfileDialogSaveAs : ; break;

		case kNPfileDialogImport : ; break;
		case kNPfileDialogExport : ; break;

		default : break;
	}

	return NULL;
}


//-----------------------------------------------------------------------------
int npWriteKML (const void* str, int wordSize, int size, FILE* file, void* dataRef)
{
	return fwrite( str, 1, strlen(str), file );
}



void npSaveKML (FILE* file, void* dataRef)
{

}


//-----------------------------------------------------------------------------
void npImportKML (FILE* file, int type, void* dataRef)
{
	
}

//-----------------------------------------------------------------------------
void npExportKML (FILE* file, void* dataRef)
{

}

//-----------------------------------------------------------------------------

// if not saved then opens SaveAs dialog before reseting app
void npCloseFileKML (int size, void* dataRef);


//-----------------------------------------------------------------------------
void npKMLGetAttrib (int size, void* dataRef)
{

}

//-----------------------------------------------------------------------------
void npKMLSetAttrib (int size, void* dataRef)
{

}

